#! /usr/local/bin/perl

#require ruslang;

$space='<|>';


$inputfile=lc ($ARGV[0]);
$outputfile=lc($ARGV[1]);
if ($inputfile eq '') {die 'Usage postflt.pl input-file [output-file]'};
if ($outputfile eq '' || $outputfile eq $inputfile){
$outputfile=$inputfile;
$outputfile =~ s/\..{0,3}$/\.new/;}
unless ($outputfile=~/\.new/){$outputfile.='.new'};

open (mdat,"<$inputfile")||die("Can\'t read file");
@curbase=<mdat>;
close mdat;
$alldata=join('',@curbase);

#predwaritelnye zameny

$alldata =~s/< >//gm;
$alldata =~s/ +/ /gm;
$alldata =~s/\s+\n/\n/gs;
$alldata =~s/\n\s+/\n/gs;

#clear previous styles
$alldata =~s/^\@[^ ]+ = //gm;
$alldata =~s/<\$\&([^>])>//gm;

if ($alldata !~ m/^\@Z_STYLE70 =/s){$alldata="\@Z_STYLE70 = \n".$alldata};


#wosstanawliwaem te simvoly, kotorye ne exportiruet word
$alldata=~s/<#96#>/\x96/mg;
$alldata=~s/<#97#>/\x97/mg;
$alldata=~s/<#AB#>/\xAB/mg;
$alldata=~s/<#BB#>/\xBB/mg;
$alldata=~s/<#95#>/\x95/mg;
$alldata=~s/<#93#>/\x93/mg;
$alldata=~s/<#94#>/\x94/mg;



$bdata=$alldata;
$bdata=~s/>>/#2#2#/g;
$edata='';

#begin replacing

while ($bdata=~m/(<\$E[^>]+>)/s){
#print $1,"\n";
$alldata=$`;
$fn=$1;
$bdata=$';
$alldata=processtext($alldata);
$fn=processeqn($fn);

$edata=$edata.$alldata.$fn;
#print "c1\n";
}


$alldata=$bdata;
$alldata=processtext($alldata);
$edata=$edata.$alldata;

$edata=~s/#2#2#/>>/g;





open (mdat,">$outputfile")||die("Can\'t write file");
print mdat $edata;

close mdat;

exit (0);

#####################################################

sub processtext{
my($intext)=shift;


$intext =~s/-/\x96/gm;
$intext =~s/([\xC0-\xFF]) \x96 ([\xC0-\xFF])/$1 \x97 $2/gm;
$intext =~s/^\x96 ([\xC0-\xFF])/\x97 $1/gm;
$intext =~s/ \x96 ([\xC0-\xFF])/ \x97 $1/gm;
$intext =~s/([\xC0-\xFF]) \x96 /$1 \x97 /gm;
$intext =~s/([\xC0-\xFF])\x96/$1-/gm;
$intext =~s/\x96([\xC0-\xFF])/-$1/gm;
$intext =~s/([XVI]) \x97 ([XVI])/$1\x96$2/gm;
$intext =~s/(\d)\x97(\d)/$1<196>$2/gm;
$intext =~s/(\d) <197> (\d)/$1 <196> $2/gm;

#$intext =~s/\*/\x95/gm;
$intext =~s/(\d) \%/$1\%/gm;


#kavycki
$intext =~s/\x93/\xAB/gm;
$intext =~s/\x94/\xBB/gm;
$intext =~s/<F"([^">]+)"/<F\x93$1\x94/gm;
$intext =~s/"([^"\x0d\x0a]+)"/\xAB$1\xBB/gm;
$intext =~s/<F\x93([^\x94\x93>]+)\x94/<F"$1"/gm;



#fonts
$intext =~s/<F128M*>/<F"Symbol">/gm;
$intext =~s/<F79M*>/<F"Math-PS">/gm;
$intext =~s/<F89M*>/<F"MathA">/gm;
$intext =~s/<F50M*>/<F"ChemistryMY">/gm;
$intext =~s/<F255[DM ]>/<F255>/gm;

#stavim uzkie probely
$intext=~s/\xF2\.\s*\xE4\./\xF2\.<P4>$space<P255>\xE4\./mg;  #t.d.
$intext=~s/\xF2\.\s*\xE5\./\xF2\.<P4>$space<P255>\xE5\./mg;  #t.e.
$intext=~s/\xF2\.\s*\xEF\./\xF2\.<P4>$space<P255>\xEF\./mg;  #t.g.

$intext=~s/([\xC0-\xDF])\.<N>([\xC0-\xDF])/$1\.<P4>$space<P255>$2/mg; #inizials
$intext=~s/([\xC0-\xDF])\. *([\xC0-\xDF])/$1\.<P4>$space<P255>$2/mg;
$intext=~s/([\xC0-\xDF])\.<N>([\xC0-\xDF])/$1\.<P4>$space<P255>$2/mg;
$intext=~s/([\xC0-\xDF])\. *([\xC0-\xDF])/$1\.<P4>$space<P255>$2/mg;




return ($intext);
}

###################################
sub processeqn{
my($indata)=shift;
$indata=~s/roman *{([^}]+)}/changespace($1)/eg;
$indata=~s/font *79/symbol/g;
$indata=~s/([\(\[])\s*\^/$1 /g;
$indata=~s/\^\s*([\)\]])/ $1/g;

$indata=~s/font/\@\@font\@\@/g;
if (($indata=~/lcol/)&&($indata !~ /matrix/)){$indata=~s/lcol/lpile/g;}


#rewrite matrix
my($msdata,$mcdata,$medata,$mprefix);
$msdata=$indata;
$medata='';
while ($msdata=~/\@ms\@(.+?\@me\@)/s){
$medata.=$`;
$mcdata=$1;
$msdata=$';
$mprefix='';
#find wlogennye matricy
while ($mcdata=~/\@ms\@(.+?\@me\@$)/s){
$mprefix.='@ms@ '.$`;
$mcdata=$1;
}
$mcdata=processmatrix($mcdata);
$msdata=$mprefix.$mcdata.$msdata;

}


$indata=$medata.$msdata;

return($indata);

}


sub processmatrix{
my($indata)=shift;
my(@coltype,@rowstr,@datastr,@elemstr);
$indata=~s/\s*\@me\@//;
$indata=~s/^\s+//;
@rowstr=split('@row@',$indata);
my($cnt)=0;
my($cnt1)=0;

while ($cnt<=$#rowstr){
my($dat1);
$dat1=$rowstr[$cnt];
$dat1=~s/^\s+//;
$dat1=~s/\s+$//;
@elemstr=split('&',$dat1);
$cnt1=0;
while ($cnt1<=$#elemstr){
my($dat2);
$dat2=$elemstr[$cnt1];
$dat2=~s/^\s+//;
$dat2=~s/\s+$//;
if ($dat2=~s/\@c\@ *//){$coltype[$cnt1]='ccol'};
if ($dat2=~s/\@l\@ *//){$coltype[$cnt1]='lcol'};
if ($dat2=~s/\@r\@ *//){$coltype[$cnt1]='rcol'};
$datastr[$cnt][$cnt1]=$dat2;
$cnt1+=1;
}

$cnt+=1;
}
$cnt=0;
$cnt1=0;
my($outdata)=' matrix { ';
while ($cnt1<=$#elemstr){
$cnt=0;
$outdata.= $coltype[$cnt1].' { ';
while ($cnt<=$#rowstr){
$outdata.= $datastr[$cnt][$cnt1];
if ($cnt<$#rowstr){$outdata.= ' above '};
$cnt+=1;
}
$outdata.=' } ';
if ($cnt1<$#elemstr){$outdata.= '^ '};

$cnt1+=1;
}
$outdata.='} ';



return ($outdata);
}


sub changespace {
my($tempdata)=shift;
$tempdata=~s/ +/\^/g;
return ("roman {$tempdata}");
}